#!usr/local/bin/perl

###############################################################################
#							CONVERT_DB_TO_2.2.PL
#
# Version: 1.0.1
# Last Updated: 11 FEB 1999
#
# This program was written by Michael E. Schechter (mschechter@earthlink.net).
#
# You may copy this under the terms of the GNU General Public
# License or the Artistic License which is distributed with
# copies of Perl v5.x for UNIX.
#
# This script will take your existing .events files and convert them to the
# format used by version 2.2.0 of FrameCal.
#
# You may run this script through your web browser by calling it directly in
# the address line of your browser.
#
# To run this file, first place it in the same directory as your
# .events files.  Then, call the script through your web browser as:
#
#		http://www.yoursite.com/cgi-bin/dbs/yourcal/convert_db_to_2.2.pl
#
# The script will add in a blank field where the category would be placed for
# an event in 2.2.0.  After the script is run, you will be presented with a
# report detailing what the script has done.  Your .events files (original)
# will NOT be deleted by the script, just modified.  After you have run the
# script, remove it from the directory, so a "visitor" to your site won't try
# to run it again.
###############################################################################

$| = 1;
$path_to_db = ".";
opendir(DIR, "$path_to_db/");
@files_to_mod = grep { /\.events$/i } readdir (DIR);
closedir(DIR);
print "Content-type: text/html\n\n";
&header;
foreach $file ( @files_to_mod ) {
	open (DATABASE, "$path_to_db/$file") || &open_error ( "$file" );
	open (TEMPFILE, ">>$path_to_db/temp.file") || &open_error ( "temp.file" );
	while (<DATABASE>) {
		($day,$time,$user,$id) = split( /\|/, $_);
		chomp( $id );
		$new_entry = "$day\|$time\|$user\|\|$id";
		print (TEMPFILE "$new_entry\n");
	}
	close( DATABASE );
	close( TEMPFILE );
	unlink( "$path_to_db/$file" );
	rename( "$path_to_db/temp.file", "$path_to_db/$file" );
	push( @dbs_added, $file );
}
print "<center><h3>Conversion Results</h3></center>";
print "<b>The following database files were modified:</b><p><blockquote>";
print "@dbs_added</blockquote><p>";
&footer;

sub open_error {
    my ($filename) = @_;
    print "I am really sorry, but for some reason I was unable to open
    <b>$filename<b>.  Please read through the source for this script and
    verify that all file paths are correct for your implementation.";
	if( @dbs_added ) {
		print "The following database files were modified up to this point:<p><blockquote>";
		print "@dbs_added</blockquote><p>";
	}
    &footer;
    die;
}

sub header {
	print qq!<html><head><title>Conversion Results</title></head><body>!;
}

sub footer {
	print qq!</body></html>!;
}
